diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/mainbus/wdlink.h sys/arch/arm32/mainbus/wdlink.h
*** sys/arch/arm32.orig/mainbus/wdlink.h	Thu Jan  1 01:00:00 1970
--- sys/arch/arm32/mainbus/wdlink.h	Thu Jun 13 02:57:04 1996
***************
*** 0 ****
--- 1,112 ----
+ /*
+  * Copyright (c) 1994, 1995 Charles M. Hannum.  All rights reserved.
+  *
+  * DMA and multi-sector PIO handling are derived from code contributed by
+  * Onno van der Linden.
+  *
+  * Atapi support added by Manuel Bouyer.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *  This product includes software developed by Charles M. Hannum.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ 
+ 
+ #undef WDDEBUG
+ /* #undef DIAGNOSTIC */
+ 
+ struct wdc_link {
+ 	int flags;
+ 	int openings;
+ };
+ 
+ struct wd_link {
+ 	u_char type;  
+ #define DRIVE 0
+ #define BUS 1
+ 	caddr_t wdc_softc;
+ 	caddr_t wd_softc;
+ 	struct wdc_link *ctlr_link;
+ 	struct wdparams sc_params;
+     /* Long-term state: */
+ 	u_int8_t openings;
+     int sc_drive;                   /* physical unit number */
+     int sc_state;                   /* control state */
+ #define RECAL           0               /* recalibrate */
+ #define RECAL_WAIT      1               /* done recalibrating */
+ #define GEOMETRY        2               /* upload geometry */
+ #define GEOMETRY_WAIT   3               /* done uploading geometry */
+ #define MULTIMODE       4               /* set multiple mode */
+ #define MULTIMODE_WAIT  5               /* done setting multiple mode */
+ #define OPEN            6               /* done with open */
+     int sc_mode;                    /* transfer mode */
+ #define WDM_PIOSINGLE   0               /* single-sector PIO */
+ #define WDM_PIOMULTI    1               /* multi-sector PIO */
+ #define WDM_DMA         2               /* DMA */
+     int sc_multiple;                /* multiple for WDM_PIOMULTI */
+     int sc_flags;                   /* drive characteistics found */
+ #define WDF_LOCKED      0x01
+ #define WDF_WANTED      0x02
+ #define WDF_WLABEL      0x04            /* label is writable */
+ #define WDF_LABELLING   0x08            /* writing label */
+ /* XXX Nothing resets this yet, but disk change sensing will when ATAPI is
+    implemented. */
+ #define WDF_LOADED      0x10            /* parameters loaded */
+ #define WDF_32BIT       0x20            /* can do 32-bit transfer */
+ #define WDF_WAIT 		0x40			/* waiting for resourses */
+     daddr_t sc_badsect[127];        /* 126 plus trailing -1 marker */
+ 	struct disklabel * sc_lp;	/* label info for this disk */
+ };
+ 
+ struct wdc_xfer {
+     struct wdc_link *c_link;   /* controller structure info */
+     struct wd_link *d_link;   /* drive/bus structure info */
+ 	volatile long c_flags; /* handle also B_READ and B_WRITE */
+ #define C_INUSE 0x01
+ #define C_ATAPI 0x02
+ #define C_ERROR 0x04
+ 	/* Information about the current transfer  */
+ 	struct buf *c_bp;
+ 	void *atapi_cmd;
+ 	void* databuf;
+ 	daddr_t c_blkno;       /* starting block number */
+ 	int c_bcount;          /* byte count left */
+ 	int c_skip;            /* bytes already transferred */
+ 	int c_nblks;           /* number of blocks currently transferring */
+ 	int c_nbytes;          /* number of bytes currently transferring */
+ 	u_long c_p_offset;  /* offset of the partition */
+ 	TAILQ_ENTRY(wdc_xfer) c_xferchain;
+ 	LIST_ENTRY(wdc_xfer) free_list;
+ };
+ 
+ 
+ void wdc_exec_xfer __P((struct wd_link *, struct wdc_xfer *));
+ struct wdc_xfer * wdc_get_xfer __P((struct wdc_link *, int));
+ int wdc_get_parms __P((struct wd_link *));
+ void wderror __P((struct wd_link* , struct buf *, char *));
+ void wddone __P((struct wd_link*, struct buf*));
+ int wdccommand __P((struct wd_link *, int, int, int, int, int, int));
+ int wdcdumpprecalibrated __P((struct wd_link *));
+ 
+ #define IDE_NOSLEEP 0x01
diff -c -r -N --exclude exp --exclude compile sys/arch/arm32.orig/mainbus/wdreg.h sys/arch/arm32/mainbus/wdreg.h
*** sys/arch/arm32.orig/mainbus/wdreg.h	Sun May 12 22:34:06 1996
--- sys/arch/arm32/mainbus/wdreg.h	Thu Jun 13 02:57:04 1996
***************
*** 47,52 ****
--- 47,53 ----
  #define	wd_precomp	0x004	/* write precompensation (W) */
  #define	wd_features	0x004	/* features (W) */
  #define	wd_seccnt	0x008	/* sector count (R/W) */
+ #define wd_ireason	0x008   /* interrupt reason (R/W) (for atapi) */
  #define	wd_sector	0x00c	/* first sector number (R/W) */
  #define	wd_cyl_lo	0x010	/* cylinder address, low byte (R/W) */
  #define	wd_cyl_hi	0x014	/* cylinder address, high byte (R/W) */
***************
*** 119,124 ****
--- 120,147 ----
  #define	WDSD_CHS	0x00	/* cylinder/head/sector addressing */
  #define	WDSD_LBA	0x40	/* logical block addressing */
  
+ /* Commands for ATAPI devices */
+ #define ATAPI_CHECK_POWER_MODE      0xe5
+ #define ATAPI_EXEC_DRIVE_DIAGS      0x90
+ #define ATAPI_IDLE_IMMEDIATE        0xe1
+ #define ATAPI_NOP           0x00
+ #define ATAPI_PACKET_COMMAND        0xa0
+ #define ATAPI_IDENTIFY_DEVICE       0xa1
+ #define ATAPI_SOFT_RESET        0x08
+ #define ATAPI_SET_FEATURES      0xef
+ #define ATAPI_SLEEP         0xe6
+ #define ATAPI_STANDBY_IMMEDIATE     0xe0
+ 
+ /* ireason */
+ #define WDCI_CMD         0x01    /* command(1) or data(0) */
+ #define WDCI_IN          0x02    /* transfer to(1) or from(0) the host */
+ #define WDCI_RELEASE     0x04    /* bus released until completion */
+ 
+ #define PHASE_CMDOUT    (WDCS_DRQ | WDCI_CMD)
+ #define PHASE_DATAIN    (WDCS_DRQ | WDCI_IN)
+ #define PHASE_DATAOUT   WDCS_DRQ
+ #define PHASE_COMPLETED (WDCI_IN | WDCI_CMD)
+ #define PHASE_ABORTED   0
  
  #ifdef _KERNEL
  /*
